#include <stdbool.h>
#include <stdarg.h>
#include <stdint.h>

extern void   HttpAddChar  (char c);
extern void   HttpFillChar (char c, int length);
extern int    HttpAddText  (const char* text);
extern int    HttpAddV     (char *fmt, va_list argptr);
extern int    HttpAddF     (char *fmt, ...);
extern void   HttpAddData  (const char* data, int length);
extern void   HttpAddStream(void (*startFunction)(void), int (*enumerateFunction)(void));

extern void   HttpReadRequest (char *p, int len, char** ppMethod, char** ppPath, char** ppQuery, char** ppLastModified);
extern char*  HttpGetNextLine (char* p, char* pE);
extern void   HttpSplitRequest(char* p, char** ppMethod, char** ppPath, char** ppQuery);
extern void   HttpSplitHeader (char* p, char** ppName, char** ppValue);
extern char*  HttpSplitQuery  (char* p, char** ppName, char** ppValue);
extern void   HttpDecodeValue (char* value);

extern int  (*HttpRequestFunction)(char *pPath, char* pLastModified, char *pQuery);
extern void (*HttpReplyFunction)(int todo);

extern bool   HttpTrace;
extern void   HttpHandleRequest(int   size, char* pRequestStream, uint32_t positionInRequestStream, int* pToDo);
extern void   HttpSendReply    (int* pSize, char* pReplyStream,   uint32_t positionInReplyStream, uint16_t mss, int todo);

extern void   HttpDateFromDateTime(const char* date, const char *ptime, char* ptext);
extern void   HttpDateFromNow(char* pText);

#define HTTP_DATE_LENGTH 30

